
; Public Domain

; test run command: *.*; .; .

%include "lmacros3.mac"
%include "eld.mac"
%include "eldcall.mac"
%include "elddata.mac"

%assign _CATCHINT0C 0
%assign _CATCHINT0D 0
%assign _CATCHINTFAULTCOND 0
%assign _DEBUG 0
%assign _DELAY_BEFORE_BP 0
%assign _DHIGHLIGHT 0
%assign _GETLINEHIGHLIGHT 0
%assign _IMMASM 0
%assign _INPUT_FILE_BOOT 0
%assign _INPUT_FILE_HANDLES 0
%assign _MS_0RANGE_COMPAT 0
%assign _PM 0
%assign _RH 0
%assign _SYMBOLIC 0
%assign _VXCHG 0
%include "options.mac"

%include "iniload.mac"

	cpu 8086

	addsection RELOCATEDDATA, nobits vstart=_ELD_RELOC_VSTART
relocateddata:

	addsection HEADER, start=0

	istruc ELD_HEADERX
at eldhxHeader
		; ELD executable header
	istruc ELD_HEADER
at eldhSignature,	db "ELD1"
			db 0,0,0
			db 26
at eldhCodeOffset,	dd CODEOFFSET
at eldhCodeImageLength,	dw code_size
at eldhCodeAllocLength,	dw 0
at eldhDataOffset,	dd DATAOFFSET
at eldhDataImageLength,	dw data_size
at eldhDataAllocLength,	dw total_data_size - data_size
at eldhCodeEntrypoint,	dw linker - code
at eldhReserved
at eldhExtensionSize,	dw header_extension_end - $$
	iend
at eldhxDescriptionOffset,	dd description
at eldhxHelpOffset,		dd DATAOFFSET + msg.help - datastart
header_extension_end:
	iend

description:		asciz "List DOS files from directories."

	align 16, db 0

	eldstrict on

CODEOFFSET equ $ - $$
	addsection CODE, follows=HEADER vstart=_ELD_CODE_VSTART
%define CODEFIXUP - code + 0
code:
		; ELD instance header
	istruc ELD_INSTANCE
at eldiStartCode
at eldiEndCode
at eldiStartData
at eldiEndData
at eldiIdentifier,	fill 8, 32, db "DOS DIR"
	iend


run:
	push ss
	pop es

run_dos:
	extcallcall InDOS
	extcallcall yy_dos_parse_name
	call parse_verbose

	push bx

	mov ah, 2Fh			; get DTA
	extcallcall ispm
	jnz .rm

subcpu 286
	push word 0
	push word 21h
	extcall intcall_ext_return_es, PM required	; must NOT be extcallcall
	pop dx				; discard interrupt number
	pop dx				; get es
subcpureset
	jmp @F
.rm:
	int 21h
	mov dx, es
@@:

reloc	mov word [originaldta], bx
internaldatarelocation
reloc	mov word [originaldta + 2], dx
internaldatarelocation

reloc	mov ax, word [relocateddata]
linkdatarelocation ext_inject_handler
reloc	mov word [originalinject], ax
internaldatarelocation
reloc2	mov word [relocateddata], inject
linkdatarelocation ext_inject_handler, -4
internalcoderelocation
	call get_es_ext
reloc	setopt [es:code + eldiFlags], eldifResident
internalcoderelocation -3	; mark block as resident
	 push ss
	 pop es

	houdini
reloc	mov dx, dta
internaldatarelocation
	mov ah, 1Ah		; set DTA
	extcallcall _doscall

	pop dx

reloc	mov word [findnext_function_number], 714Fh
internaldatarelocation -4
	mov ax, 714Eh
	mov cx, 16h		; find all files and directories
	mov si, 1
reloc	mov di, finddata
internaldatarelocation
reloc	rol byte [prefersfn], 1
internaldatarelocation
	jc .sfn_try
	stc
	extcallcall _doscall
	jnc .lfn_found
	cmp ax, 1
	je .sfn_try
	cmp ax, 7100h
	je .sfn_try
	jmp .notfound

.lfn_found:
reloc	mov word [findhandle], ax
internaldatarelocation
reloc	mov byte [findhandle_set], 0FFh
internaldatarelocation -3
	jmp .loop

.sfn_try:
reloc	mov word [findnext_function_number], 4F00h
internaldatarelocation -4
	mov ax, 4E00h
	mov cx, 16h		; find all files and directories
	extcallcall _doscall
	jc .notfound

.loop:
reloc	cmp byte [findnext_function_number + 1], 71h
internaldatarelocation -3
	je .have_lfn

reloc	mov al, byte [dta.attrib]
internaldatarelocation
reloc	mov byte [finddata.attrib], al
internaldatarelocation

reloc	mov ax, word [dta.time]
internaldatarelocation
reloc	mov word [finddata.time], ax
internaldatarelocation

reloc	mov ax, word [dta.date]
internaldatarelocation
reloc	mov word [finddata.date], ax
internaldatarelocation

reloc	mov ax, word [dta.size]
internaldatarelocation
reloc	mov word [finddata.sizelow], ax
internaldatarelocation

reloc	mov ax, word [dta.size + 2]
internaldatarelocation
reloc	mov word [finddata.sizelow + 2], ax
internaldatarelocation

	xor ax, ax
reloc	mov word [finddata.sizehigh], ax
internaldatarelocation
reloc	mov word [finddata.sizehigh + 2], ax
internaldatarelocation

reloc	mov si, dta.name
internaldatarelocation
reloc	mov di, finddata.fullname
internaldatarelocation
	mov cx, words(14)
	rep movsw

reloc	mov byte [finddata.shortname], al
internaldatarelocation

.have_lfn:

reloc	mov si, finddata.shortname
internaldatarelocation
	cmp byte [si], 0
	jne @F
reloc	mov si, finddata.fullname
internaldatarelocation
@@:

	cmp byte [si], '.'	; dot ?
	jne @F
	cmp word [si + 1], "."	; dot and NUL ?
	je .next		; dotdot, skip -->
	cmp byte [si + 1], 0	; NUL ?
	je .next		; dot, skip -->
@@:

reloc	mov di, relocateddata
linkdatarelocation line_out
	mov cx, 8

@@:
	lodsb
	cmp al, '.'
	je @F
	cmp al, 0
	je .no_ext
	stosb
	loop @B
	lodsb
	cmp al, '.'
	je @F
	dec si			; doesn't fit, nothing sensible here

@@:
	inc cx
	mov al, 32
	rep stosb

	mov cl, 3
@@:
	lodsb
	cmp al, 0
	je @F
	stosb
	loop @B
	jmp @F

.no_ext:
	add cx, 1 + 3

@@:
	inc cx
	inc cx
	mov al, 32
	rep stosb


reloc	mov bl, byte [finddata.attrib]
internaldatarelocation

	mov al, '-'
	test bl, ATTR_ARCHIVE
	jz @F
	mov al, 'A'
@@:
	stosb
	mov al, '-'
	test bl, ATTR_HIDDEN
	jz @F
	mov al, 'H'
@@:
	stosb
	mov al, '-'
	test bl, ATTR_READONLY
	jz @F
	mov al, 'R'
@@:
	stosb
	mov al, '-'
	test bl, ATTR_SYSTEM
	jz @F
	mov al, 'S'
@@:
	stosb
	mov ax, 2020h
	stosw

	test bl, ATTR_DIRECTORY
	jz @F
reloc	mov si, msg.dirinsteadsize
internaldatarelocation
.nosize:
	extcallcall copy_single_counted_string
	jmp @FF

@@:
reloc	cmp word [finddata.sizehigh + 2], strict byte 0
internaldatarelocation -3
	je .sizefits

reloc	mov si, msg.sizetoolarge
internaldatarelocation
	jmp .nosize

.sizefits:
reloc	mov si, word [finddata.sizehigh] 	; from FAT+ upper size bits
internaldatarelocation
reloc	mov dx, word [finddata.sizelow + 2]
internaldatarelocation
reloc	mov ax, word [finddata.sizelow]
internaldatarelocation
	xor cx, cx
	mov bx, 4+4
	extcallcall disp_dxax_times_cx_width_bx_size.store

@@:
	mov ax, 2020h
	stosw
reloc	mov bx, word [finddata.date]
internaldatarelocation
reloc	mov si, word [finddata.time]
internaldatarelocation

	mov ax, bx
	mov cx, 9
	shr ax, cl
	add ax, 1980
	xor dx, dx
	mov cl, 4
	extcallcall dec_dword_minwidth
	mov al, '-'
	stosb
	mov ax, bx
	mov cl, 5
	shr ax, cl
	and ax, 15
	mov cl, 2
	extcallcall dec_dword_minwidth
	mov al, '-'
	stosb
	mov ax, bx
	and ax, 31
	extcallcall dec_dword_minwidth
	mov al, 32
	stosb
	mov ax, si
	mov cl, 11
	shr ax, cl
	mov cl, 2
	extcallcall dec_dword_minwidth
	mov al, ':'
	stosb
	mov ax, si
	mov cl, 5
	shr ax, cl
	and ax, 63
	mov cl, 2
	extcallcall dec_dword_minwidth
	mov al, ':'
	stosb
	mov ax, si
	and ax, 31
	shl ax, 1
	extcallcall dec_dword_minwidth

reloc	cmp byte [finddata.shortname], 0
internaldatarelocation -3
	je @F
	mov ax, 2020h
	stosw
	extcallcall putsline
reloc	mov dx, finddata.fullname
internaldatarelocation
	extcallcall putsz
reloc	mov dx, msg.linebreak
internaldatarelocation
	extcallcall putsz
	jmp .next

@@:
	extcallcall putsline_crlf

.next:
reloc	mov ax, word [findnext_function_number]
internaldatarelocation
reloc	mov bx, word [findhandle]
internaldatarelocation
	mov si, 1
reloc	mov di, finddata
internaldatarelocation
	stc
	extcallcall _doscall
	jnc .loop

	extcallcall cmd3


.notfound:
reloc	mov dx, msg.notfound
internaldatarelocation
	extcallcall putsz
	extcallcall cmd3


parse_verbose.loop:
	lodsb
parse_verbose:
	extcallcall skipcomm0
	extcallcall iseol?
	jne @F
	retn

@@:
	dec si
reloc	mov dx, msg.string_sfn
internaldatarelocation
	extcallcall isstring?
	jne @F
reloc	mov byte [prefersfn], 0FFh
internaldatarelocation -3
	jmp .loop

@@:
	extcallcall error

inject:
reloc	mov dx, word [originaldta]	; dx -> original DTA
internaldatarelocation
	mov ah, 1Ah			; set DTA (restoring)
	extcallcall ispm
	jnz .rm

subcpu 286
reloc	push word [originaldta + 2]
internaldatarelocation			; ds => original DTA (86M segment)
	push word 21h
	extcall intcall_ext_return_es, PM required	; must NOT be extcallcall
	pop dx				; discard interrupt number
	pop dx				; discard es
subcpureset
	jmp @F
.rm:
reloc	mov ds, word [originaldta + 2]	; ds => original DTA
internaldatarelocation
	int 21h
	 push ss
	 pop ds
@@:

reloc	mov bx, word [findhandle]	; bx = find handle, if any
internaldatarelocation
reloc	rol byte [findhandle_set], 1	; find handle set ?
internaldatarelocation
	jnc @F				; no -->
reloc	not byte [findhandle_set]
internaldatarelocation
	mov ax, 71A1h
	extcallcall _doscall		; LFN find close
@@:

reloc	mov cx, word [originalinject]
internaldatarelocation
	call get_es_ext
reloc	clropt [es:code + eldiFlags], eldifResident
internalcoderelocation -3		; mark block as no longer resident
	 push ss
	 pop es
	jcxz @F
	jmp cx

@@:
	extcall cmd3_not_inject


get_es_ext:
reloc	mov es, word [relocateddata]
linkdatarelocation extdssel
	extcallcall ispm
	jz @F
reloc	mov es, word [relocateddata]
linkdatarelocation extseg
@@:
	retn


start:
	mov bx, es
	 push ss
	 pop es
	extcallcall skipcomma
	extcallcall iseol?
	je .help
	call run
@@:
	call uninstall_oneshot
	xor ax, ax
	retf

.help:
reloc	mov dx, msg.help
internaldatarelocation
	extcallcall putsz
	jmp @B


uninstall_oneshot:
reloc	testopt [ss:relocateddata], 1
linkdatarelocation options7, -3
	jnz @F

reloc	mov ax, word [cs:code + eldiEndCode]
internalcoderelocation
reloc	sub ax, word [cs:code + eldiStartCode]
internalcoderelocation
reloc	sub word [relocateddata], ax
linkdatarelocation extseg_used

reloc	mov ax, word [cs:code + eldiEndData]
internalcoderelocation
reloc	sub ax, word [cs:code + eldiStartData]
internalcoderelocation
reloc	sub word [relocateddata], ax
linkdatarelocation extdata_used
@@:
	retn


DATAOFFSET equ CODEOFFSET + code_size
	addsection DATA, follows=CODE vstart=_ELD_DATA_VSTART
%define DATAFIXUP - datastart + 0
datastart:

findhandle_set:		db 0
prefersfn:		db 0

msg:
.string_sfn:		asciz "SFN"
.dirinsteadsize:	countedb "   [DIR]"
.sizetoolarge:		countedb ">256 TiB"
.notfound:		db "File not found."
.linebreak:		asciz 13,10
.help:		db "Run with a pathname as parameter.",13,10
		db "Last component may include wildcards.",13,10
		db 13,10
		db "After the pathname, keywords may follow:",13,10
		db 9,"SFN",9,"Use DOS SFN search even if LFN available",13,10
		asciz

uinit_data: equ $

	align 16, db 0
data_size equ $ - datastart

	absolute uinit_data

	alignb 2
originaldta:	resd 1
originalinject:	resw 1
findnext_function_number:
		resw 1
findhandle:	resw 1
dta:		resb 15h
.attrib:	resb 1
.time:		resw 1
.date:		resw 1
.size:		resd 1
.name:		resb 13

	alignb 2
finddata:
.attrib:	resd 1
		resq 2
.time:		resw 1
.date:		resw 1
		resd 1
.sizehigh:	resd 1
.sizelow:	resd 1
		resb 8
.fullname:	resb 260
.shortname:	resb 14

	alignb 16
uinit_data_end:

total_data_size equ $ - datastart
%assign _DATA_SIZE total_data_size

	usesection CODE

%include "eldlink.asm"

	align 16
code_size equ $ - code

